@echo off

set cdiname=disc
set elfname=1st_read

@echo:==================================================
@echo: = [ ++     Data 2 CDi  by PH3NOM 2009     ++ ] = 
@echo: = [ ++ A Sega Dreamcast Self-boot Utility ++ ] = 
@echo:==================================================
pause

:ELF2BIN
IF EXIST %CD%\data\1st_read.bin GOTO MAKEISO
IF NOT EXIST %CD%\data\%elfname%.elf GOTO EXIT_ERROR
copy %CD%\data\%elfname%.elf %CD% >nul
sh-elf-objcopy -R .stack -O binary %elfname%.elf 1st_read
GOTO SCRAMBLEBIN

:SCRAMBLEBIN
scramble 1st_read 1st_read.bin
del 1st_read
move 1st_read.bin %CD%\data >nul
del %elfname%.elf
GOTO MAKEISO

:MAKEISO
mkisofs -R -C 0,11702 -V %cdiname% -G IP.BIN -l -o data.iso data
GOTO MAKECDi

:MAKECDi
cdi4dc data.iso %cdiname%.CDi
del data.iso
GOTO RunNullDC

:RunNullDC
@echo:===================================================
@echo: = Launching NullDC...                           =   
@echo:===================================================
CD "%CD%"\nullDC
nullDC_Win32_Release-NoTrace
GOTO EXIT_SUCCESS

:EXIT_ERROR
@echo:=========================================================
@echo:= [ ++  Data 2 CDi ERROR:                         ++ ] =
@echo:= [ ++  %elfname%.elf OR 1st_read.bin NOT FOUND  ++ ] =
@echo:=========================================================
Pause
EXIT

:EXIT_SUCCESS
@echo:===================================================
@echo: = [ ++   Data 2 CDi  Processing Complete   ++ ] =
@echo:===================================================
Pause
EXIT